"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _awsSdk = _interopRequireDefault(require("aws-sdk"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _mimeTypes = _interopRequireDefault(require("mime-types"));

var _axios = _interopRequireDefault(require("axios"));

var _exponentialBackoff = require("exponential-backoff");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var SortOrder = {
  ASC: 'ASC',
  DESC: 'DESC'
};

function sortFilesByDate(filesList) {
  var sortByDate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : SortOrder.ASC;
  var result = filesList.sort(function (a, b) {
    if (sortByDate === SortOrder.DESC) {
      return b.lastModified.getTime() - a.lastModified.getTime();
    }

    return a.lastModified.getTime() - b.lastModified.getTime();
  });
  return result;
}

var SpacesClient = /*#__PURE__*/function () {
  function SpacesClient(endpoint, bucket) {
    var accessKeyId = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var secretAccessKey = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var digitalOceanAPIToken = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
    var cdnEndpointId = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : null;
    (0, _classCallCheck2["default"])(this, SpacesClient);
    this.endpoint = endpoint;
    this.bucket = bucket;
    this.digitalOceanAPIToken = digitalOceanAPIToken;
    this.cdnEndpointId = cdnEndpointId;
    var options = {
      endpoint: endpoint
    };

    if (accessKeyId) {
      options.accessKeyId = accessKeyId;
    }

    if (secretAccessKey) {
      options.secretAccessKey = secretAccessKey;
    }

    this.s3client = new _awsSdk["default"].S3(options);
  }

  (0, _createClass2["default"])(SpacesClient, [{
    key: "getURL",
    value: function getURL(path) {
      return "https://".concat(this.bucket, ".").concat(this.endpoint, "/").concat(path);
    }
  }, {
    key: "getCDNURL",
    value: function getCDNURL(path) {
      var url = this.getURL(path);
      return url.replace(/digitaloceanspaces/, 'cdn.digitaloceanspaces');
    }
  }, {
    key: "isFilePublic",
    value: function () {
      var _isFilePublic = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(filePath) {
        var acl, isPublic;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.s3client.getObjectAcl({
                  Bucket: this.bucket,
                  Key: filePath
                }).promise();

              case 2:
                acl = _context.sent;
                isPublic = acl.Grants.some(function (_ref) {
                  var Grantee = _ref.Grantee,
                      Permission = _ref.Permission;
                  var isAllUsers = Grantee.URI && Grantee.URI.match(/AllUsers/);
                  var isRead = Permission === 'READ';
                  return isAllUsers && isRead;
                });
                return _context.abrupt("return", isPublic);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function isFilePublic(_x) {
        return _isFilePublic.apply(this, arguments);
      }

      return isFilePublic;
    }()
  }, {
    key: "getCDNEndpointId",
    value: function () {
      var _getCDNEndpointId = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        var _this = this;

        var cdnEndpointsResponse, cdnEndpoints, currentCdnEndpoint;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (this.digitalOceanAPIToken) {
                  _context2.next = 2;
                  break;
                }

                throw new Error('No API Token configured');

              case 2:
                if (!this.cdnEndpointId) {
                  _context2.next = 4;
                  break;
                }

                return _context2.abrupt("return", this.cdnEndpointId);

              case 4:
                _context2.next = 6;
                return _axios["default"].request({
                  url: 'https://api.digitalocean.com/v2/cdn/endpoints',
                  headers: {
                    Authorization: "Bearer ".concat(this.digitalOceanAPIToken)
                  }
                });

              case 6:
                cdnEndpointsResponse = _context2.sent;
                cdnEndpoints = cdnEndpointsResponse.data.endpoints;
                currentCdnEndpoint = cdnEndpoints.find(function (_ref2) {
                  var origin = _ref2.origin;

                  var _origin$split = origin.split('.'),
                      _origin$split2 = (0, _slicedToArray2["default"])(_origin$split, 1),
                      endpointBucket = _origin$split2[0];

                  return _this.bucket === endpointBucket;
                });

                if (currentCdnEndpoint) {
                  _context2.next = 11;
                  break;
                }

                throw new Error("No CDN endpoint found for bucket: ".concat(this.bucket));

              case 11:
                this.cdnEndpointId = currentCdnEndpoint.id;
                return _context2.abrupt("return", this.cdnEndpointId);

              case 13:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getCDNEndpointId() {
        return _getCDNEndpointId.apply(this, arguments);
      }

      return getCDNEndpointId;
    }()
  }, {
    key: "uploadFile",
    value: function () {
      var _uploadFile = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(uploadFilePath, destinationPath) {
        var _this2 = this;

        var permission,
            options,
            _options$exponentialB,
            exponentialBackoff,
            _options$purgeCache,
            purgeCache,
            spacesOptions,
            makeUpload,
            _args4 = arguments;

        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                permission = _args4.length > 2 && _args4[2] !== undefined ? _args4[2] : 'private';
                options = _args4.length > 3 && _args4[3] !== undefined ? _args4[3] : {};
                _options$exponentialB = options.exponentialBackoff, exponentialBackoff = _options$exponentialB === void 0 ? false : _options$exponentialB, _options$purgeCache = options.purgeCache, purgeCache = _options$purgeCache === void 0 ? false : _options$purgeCache, spacesOptions = (0, _objectWithoutProperties2["default"])(options, ["exponentialBackoff", "purgeCache"]);

                makeUpload = /*#__PURE__*/function () {
                  var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
                    var cdnEndpointId;
                    return _regenerator["default"].wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            _context3.next = 2;
                            return _this2.s3client.upload(_objectSpread({
                              Bucket: _this2.bucket,
                              Body: _fs["default"].createReadStream(uploadFilePath),
                              Key: destinationPath,
                              ACL: permission === 'public' ? 'public-read' : permission,
                              // ContentDisposition: 'attachment',
                              ContentType: _mimeTypes["default"].lookup(uploadFilePath)
                            }, spacesOptions)).promise();

                          case 2:
                            if (!purgeCache) {
                              _context3.next = 8;
                              break;
                            }

                            _context3.next = 5;
                            return _this2.getCDNEndpointId();

                          case 5:
                            cdnEndpointId = _context3.sent;
                            _context3.next = 8;
                            return _axios["default"].request({
                              url: "https://api.digitalocean.com/v2/cdn/endpoints/".concat(cdnEndpointId, "/cache"),
                              method: 'DELETE',
                              headers: {
                                Authorization: "Bearer ".concat(_this2.digitalOceanAPIToken)
                              },
                              data: {
                                files: [destinationPath]
                              }
                            });

                          case 8:
                            return _context3.abrupt("return", _this2.getCDNURL(destinationPath));

                          case 9:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));

                  return function makeUpload() {
                    return _ref3.apply(this, arguments);
                  };
                }();

                if (!exponentialBackoff) {
                  _context4.next = 6;
                  break;
                }

                return _context4.abrupt("return", (0, _exponentialBackoff.backOff)(function () {
                  return makeUpload();
                }));

              case 6:
                return _context4.abrupt("return", makeUpload());

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      function uploadFile(_x2, _x3) {
        return _uploadFile.apply(this, arguments);
      }

      return uploadFile;
    }()
  }, {
    key: "listPathObjects",
    value: function () {
      var _listPathObjects = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(path) {
        var data;
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.s3client.listObjectsV2({
                  Bucket: this.bucket,
                  Prefix: path
                }).promise();

              case 2:
                data = _context5.sent;
                return _context5.abrupt("return", data.Contents);

              case 4:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function listPathObjects(_x4) {
        return _listPathObjects.apply(this, arguments);
      }

      return listPathObjects;
    }()
    /**
     * List files at path sorting them by Last Modified date.
     * @param {String} path Path in DO Spaces to list files
     * @param {Object} options Options for the list
     * @param {('ASC'|'DESC')} options.sortByDate Sorting order 'ASC' or 'DESC'. 'ASC' is default.
     * @param {Boolean} options.pathOnly If true it will not return the complete
     * URL just the path in DO Spaces
     */

  }, {
    key: "listPathFiles",
    value: function () {
      var _listPathFiles = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(path) {
        var _this3 = this;

        var options,
            sortByDate,
            _options$pathOnly,
            pathOnly,
            objects,
            filesList,
            _args6 = arguments;

        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                options = _args6.length > 1 && _args6[1] !== undefined ? _args6[1] : {};
                sortByDate = options.sortByDate, _options$pathOnly = options.pathOnly, pathOnly = _options$pathOnly === void 0 ? false : _options$pathOnly;
                _context6.next = 4;
                return this.listPathObjects(path);

              case 4:
                objects = _context6.sent;
                filesList = objects.map(function (_ref4) {
                  var Key = _ref4.Key,
                      LastModified = _ref4.LastModified;
                  return {
                    url: pathOnly ? Key : _this3.getCDNURL(Key),
                    lastModified: LastModified
                  };
                });
                return _context6.abrupt("return", sortFilesByDate(filesList, sortByDate));

              case 7:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function listPathFiles(_x5) {
        return _listPathFiles.apply(this, arguments);
      }

      return listPathFiles;
    }()
  }, {
    key: "deleteObjects",
    value: function () {
      var _deleteObjects = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(objects) {
        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                return _context7.abrupt("return", this.s3client.deleteObjects({
                  Bucket: this.bucket,
                  Delete: {
                    Objects: objects.map(function (object) {
                      return {
                        Key: object.Key
                      };
                    })
                  }
                }).promise());

              case 1:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function deleteObjects(_x6) {
        return _deleteObjects.apply(this, arguments);
      }

      return deleteObjects;
    }()
  }, {
    key: "deletePaths",
    value: function () {
      var _deletePaths = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(paths) {
        var objects;
        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                objects = paths.map(function (path) {
                  return {
                    Key: path
                  };
                });
                return _context8.abrupt("return", this.deleteObjects(objects));

              case 2:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function deletePaths(_x7) {
        return _deletePaths.apply(this, arguments);
      }

      return deletePaths;
    }()
  }, {
    key: "deleteFile",
    value: function () {
      var _deleteFile = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(path) {
        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                return _context9.abrupt("return", this.deleteObjects([{
                  Key: path
                }]));

              case 1:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function deleteFile(_x8) {
        return _deleteFile.apply(this, arguments);
      }

      return deleteFile;
    }()
  }, {
    key: "deleteFolder",
    value: function () {
      var _deleteFolder = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(folderPath) {
        var objects;
        return _regenerator["default"].wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return this.listPathObjects(folderPath);

              case 2:
                objects = _context10.sent;
                return _context10.abrupt("return", this.deleteObjects(objects));

              case 4:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function deleteFolder(_x9) {
        return _deleteFolder.apply(this, arguments);
      }

      return deleteFolder;
    }()
  }, {
    key: "copyFile",
    value: function () {
      var _copyFile = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(sourcePath, destinationPath) {
        var isSourcePublic;
        return _regenerator["default"].wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return this.isFilePublic(sourcePath);

              case 2:
                isSourcePublic = _context11.sent;
                return _context11.abrupt("return", this.s3client.copyObject({
                  Bucket: this.bucket,
                  CopySource: "/".concat(this.bucket, "/").concat(sourcePath),
                  Key: destinationPath,
                  ACL: isSourcePublic ? 'public-read' : 'private'
                }).promise());

              case 4:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function copyFile(_x10, _x11) {
        return _copyFile.apply(this, arguments);
      }

      return copyFile;
    }()
  }, {
    key: "downloadFile",
    value: function () {
      var _downloadFile = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(filePathToRead, filePathToSave) {
        var _this4 = this;

        var createDirIfNotExists,
            parentPath,
            _args12 = arguments;
        return _regenerator["default"].wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                createDirIfNotExists = _args12.length > 2 && _args12[2] !== undefined ? _args12[2] : true;

                if (!createDirIfNotExists) {
                  _context12.next = 5;
                  break;
                }

                parentPath = _path["default"].dirname(filePathToSave);
                _context12.next = 5;
                return _fs["default"].promises.mkdir(parentPath, {
                  recursive: true
                });

              case 5:
                return _context12.abrupt("return", new Promise(function (resolve, reject) {
                  var fileWriteStream = _fs["default"].createWriteStream(filePathToSave);

                  _this4.s3client.getObject({
                    Bucket: _this4.bucket,
                    Key: filePathToRead
                  }).on('error', function (error) {
                    _fs["default"].unlinkSync(filePathToSave);

                    reject(error);
                  }).createReadStream().pipe(fileWriteStream);

                  fileWriteStream.on('finish', function () {
                    resolve(filePathToSave);
                  });
                }));

              case 6:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12);
      }));

      function downloadFile(_x12, _x13) {
        return _downloadFile.apply(this, arguments);
      }

      return downloadFile;
    }()
  }]);
  return SpacesClient;
}();

var _default = SpacesClient;
exports["default"] = _default;
module.exports = exports.default;